<template>
  <b-modal id="modal1" hide-footer hide-header centered ref="thisModal" class="border-0" size="600">
    <div class="row px-4 py-2">
      <div class="col-sm-12 text-center">
        <img :src="asset(type)" alt="image" class="img-fluid d-block mx-auto pointer">
        <br>
        <h5>{{title}}</h5>
        <p class="text-muted">{{body}}</p>
        <slot name="input"></slot>
      </div>
    </div>
    <br>
    <div class="row justify-content-center">
      <slot name="action"></slot>
      <div class="col-sm-3">
        <button class="btn-block btn bg-light btn-rounded" @click="hideModal">Close</button>
      </div>
    </div>
  </b-modal>
</template>
<script>
import EventBus from "@/EventBus.js";

export default {
  data() {
    return {
      imageMap: {
        info: "images/ui_elements/ic_idea.png",
        alert: "images/ui_elements/ic_alert.png"
      },
      type: null,
      title: "Modal title",
      body: "Modal body",
      data: {}
    };
  },
  mounted() {
    EventBus.$on("hideModal", value => {
      this.hideModal();
    });
  },
  methods: {
    hideModal() {
      this.$refs.thisModal.hide();
    },
    customModal(data = {}) {
      this.data = data;
      this.$refs.thisModal.show();
    },
    show(type, title, body) {
      (this.type = this.imageMap[type]),
        (this.title = title),
        (this.body = body),
        this.$refs.thisModal.show();
    }
  }
};
</script>
<style lang="scss">
</style>
